Index: code/trunk/src/core/MetaObjectList.cc
===================================================================
--- code/trunk/src/core/MetaObjectList.cc	(revision 1740)
+++ code/trunk/src/core/MetaObjectList.cc	(revision 1747)
@@ -33,7 +33,38 @@
 
 #include "MetaObjectList.h"
+#include "ObjectListBase.h"
+#include "Identifier.h"
+#include "util/Debug.h"
 
 namespace orxonox
 {
+    // ###############################
+    // ###  MetaObjectListElement  ###
+    // ###############################
+    /**
+        @brief Destructor: Removes the ObjectListBaseElement from the ObjectListBase by linking next_ and prev_ of the ObjectListBaseElement.
+    */
+    MetaObjectListElement::~MetaObjectListElement()
+    {
+        COUT(5) << "*** MetaObjectList: Removing Object from " << this->list_->getIdentifier()->getName() << "-list." << std::endl;
+        this->list_->notifyIterators(this->element_->objectBase_);
+
+        if (this->element_->next_)
+            this->element_->next_->prev_ = this->element_->prev_;
+        else
+            this->list_->last_ = this->element_->prev_; // If there is no next_, we deleted the last object and have to update the last_ pointer of the list
+
+        if (this->element_->prev_)
+            this->element_->prev_->next_ = this->element_->next_;
+        else
+            this->list_->first_ = this->element_->next_; // If there is no prev_, we deleted the first object and have to update the first_ pointer of the list
+
+        delete this->element_;
+    }
+
+
+    // ###############################
+    // ###     MetaObjectList      ###
+    // ###############################
     /**
         @brief Constructor: Sets first_ to zero.
@@ -49,5 +80,5 @@
     MetaObjectList::~MetaObjectList()
     {
-        BaseMetaObjectListElement* temp;
+        MetaObjectListElement* temp;
         while (this->first_)
         {
@@ -57,3 +88,15 @@
         }
     }
+
+    /**
+        @brief Adds an ObjectList and an element of that list to the MetaObjectList.
+        @param list The ObjectList wherein the element is
+        @param element The element wherein the object is
+    */
+    void MetaObjectList::add(ObjectListBase* list, ObjectListBaseElement* element)
+    {
+        MetaObjectListElement* temp = this->first_;
+        this->first_ = new MetaObjectListElement(list, element);
+        this->first_->next_ = temp;
+    }
 }
Index: code/trunk/src/core/MetaObjectList.h
===================================================================
--- code/trunk/src/core/MetaObjectList.h	(revision 1740)
+++ code/trunk/src/core/MetaObjectList.h	(revision 1747)
@@ -41,67 +41,23 @@
 #include "CorePrereqs.h"
 
-#include "ObjectList.h"
-#include "Identifier.h"
-#include "Debug.h"
-
 namespace orxonox
 {
-    //! Base-class of MetaObjectListElement, because those is a template
-    class BaseMetaObjectListElement
-    {
-        public:
-            /** @brief Default destructor */
-            virtual ~BaseMetaObjectListElement() {};
-
-            BaseMetaObjectListElement* next_;       //!< The next Element in the list
-    };
-
     // ###############################
     // ###  MetaObjectListElement  ###
     // ###############################
     //! The list-element of the MetaObjectList
-    template <class T>
-    class MetaObjectListElement : public BaseMetaObjectListElement
+    class _CoreExport MetaObjectListElement
     {
         public:
-            MetaObjectListElement(ObjectList<T>* list, ObjectListElement<T>* element);
-            virtual ~MetaObjectListElement();
+            /**
+                @brief Constructor: Creates the list-element with given list and element.
+            */
+            MetaObjectListElement(ObjectListBase* list, ObjectListBaseElement* element) : next_(0), element_(element), list_(list) {}
+            ~MetaObjectListElement();
 
-            ObjectListElement<T>* element_;         //!< The list element, containing the object
-            ObjectList<T>* list_;                   //!< The list, containing the element
+            MetaObjectListElement* next_;       //!< The next Element in the list
+            ObjectListBaseElement* element_;    //!< The list element, containing the object
+            ObjectListBase* list_;              //!< The list, containing the element
     };
-
-    /**
-        @brief Constructor: Creates the list-element with given list and element.
-    */
-    template <class T>
-    MetaObjectListElement<T>::MetaObjectListElement(ObjectList<T>* list, ObjectListElement<T>* element)
-    {
-        this->element_ = element;
-        this->list_ = list;
-        this->next_ = 0;
-    }
-
-    /**
-        @brief Destructor: Removes the ObjectListElement from the ObjectList by linking next_ and prev_ of the ObjectListElement.
-    */
-    template <class T>
-    MetaObjectListElement<T>::~MetaObjectListElement()
-    {
-        COUT(5) << "*** MetaObjectList: Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list." << std::endl;
-        this->list_->notifyIterators(this->element_);
-
-        if (this->element_->next_)
-            this->element_->next_->prev_ = this->element_->prev_;
-        else
-            this->list_->last_ = this->element_->prev_; // If there is no next_, we deleted the last object and have to update the last_ pointer of the list
-
-        if (this->element_->prev_)
-            this->element_->prev_->next_ = this->element_->next_;
-        else
-            this->list_->first_ = this->element_->next_; // If there is no prev_, we deleted the first object and have to update the first_ pointer of the list
-
-        delete this->element_;
-    }
 
 
@@ -109,5 +65,5 @@
     // ###     MetaObjectList      ###
     // ###############################
-    //!  The MetaObjectList contains ObjectListElements and their ObjectLists.
+    //!  The MetaObjectList contains ObjectListBaseElements and their ObjectListBases.
     /**
         The MetaObjectList is a single-linked list, containing all list-elements and their
@@ -120,22 +76,8 @@
             MetaObjectList();
             ~MetaObjectList();
-            template <class T>
-            void add(ObjectList<T>* list, ObjectListElement<T>* element);
+            void add(ObjectListBase* list, ObjectListBaseElement* element);
 
-            BaseMetaObjectListElement* first_;      //!< The first element in the list
+            MetaObjectListElement* first_;      //!< The first element in the list
     };
-
-    /**
-        @brief Adds an ObjectList and an element of that list to the MetaObjectList.
-        @param list The ObjectList wherein the element is
-        @param element The element wherein the object is
-    */
-    template <class T>
-    void MetaObjectList::add(ObjectList<T>* list, ObjectListElement<T>* element)
-    {
-        BaseMetaObjectListElement* temp = this->first_;
-        this->first_ = new MetaObjectListElement<T>(list, element);
-        this->first_->next_ = temp;
-    }
 }
 
Index: code/trunk/src/core/Namespace.cc
===================================================================
--- code/trunk/src/core/Namespace.cc	(revision 1740)
+++ code/trunk/src/core/Namespace.cc	(revision 1747)
@@ -60,5 +60,5 @@
     void Namespace::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
-        BaseObject::XMLPort(xmlelement, mode);
+        SUPER(Namespace, XMLPort, xmlelement, mode);
 
         std::string name = this->getName();
Index: code/trunk/src/core/NamespaceNode.cc
===================================================================
--- code/trunk/src/core/NamespaceNode.cc	(revision 1740)
+++ code/trunk/src/core/NamespaceNode.cc	(revision 1747)
@@ -28,5 +28,5 @@
 
 #include "NamespaceNode.h"
-#include "Debug.h"
+#include "util/Debug.h"
 
 namespace orxonox
Index: code/trunk/src/core/ObjectList.h
===================================================================
--- code/trunk/src/core/ObjectList.h	(revision 1740)
+++ code/trunk/src/core/ObjectList.h	(revision 1747)
@@ -31,6 +31,5 @@
     @brief Definition and implementation of the ObjectList class.
 
-    The ObjectList is a double-linked list, used by Identifiers to store all objects of a given class.
-    Newly created objects are added through the RegisterObject-macro in its constructor.
+    The ObjectList is a wrapper of an ObjectListBase of a given class.
     Use Iterator<class> to iterate through all objects of the class.
 */
@@ -39,48 +38,18 @@
 #define _ObjectList_H__
 
-#include <set>
-
 #include "CorePrereqs.h"
 
-#include "Iterator.h"
 #include "Identifier.h"
+#include "ObjectListIterator.h"
 
 namespace orxonox
 {
     // ###############################
-    // ###    ObjectListElement    ###
-    // ###############################
-    //! The list-element of the ObjectList
-    template <class T>
-    class ObjectListElement
-    {
-        public:
-            ObjectListElement(T* object);
-
-            T* object_;                     //!< The object
-            ObjectListElement* next_;       //!< The next element in the list
-            ObjectListElement* prev_;       //!< The previous element in the list
-    };
-
-    /**
-        @brief Constructor: Creates the list-element with an object.
-        @param object The object to store
-    */
-    template <class T>
-    ObjectListElement<T>::ObjectListElement(T* object)
-    {
-        this->object_ = object;
-        this->next_ = 0;
-        this->prev_ = 0;
-    }
-
-
-    // ###############################
     // ###       ObjectList        ###
     // ###############################
-    //! The ObjectList contains all objects of a given class.
+    //! The ObjectList contains all objects of the given class.
     /**
-        The ObjectList is used by Identifiers to store all objects of a given class.
-        Use Iterator<class> to iterate through all objects in the list.
+        Wraps the ObjectListBase of the corresponding Identifier.
+        Use ObjectListIterator<class> to iterate through all objects in the list.
     */
     template <class T>
@@ -88,96 +57,22 @@
     {
         public:
-            ObjectList();
-            ~ObjectList();
+            typedef ObjectListIterator<T> iterator;
 
-            ObjectListElement<T>* add(T* object);
+            /** @brief Returns an Iterator to the first element in the list. @return The Iterator */
+            inline static ObjectListElement<T>* begin()
+                { return ((ObjectListElement<T>*)ClassIdentifier<T>::getIdentifier()->getObjects()->begin().element_); }
 
-            /** @brief Returns the first element in the list. @return The first element */
-            inline static Iterator<T> start()
-                { return Iterator<T>(ClassIdentifier<T>::getIdentifier()->getObjects()->first_); }
+            /** @brief Returns an Iterator to the element after the last element in the list. @return The Iterator */
+            inline static ObjectListElement<T>* end()
+                { return ((ObjectListElement<T>*)ClassIdentifier<T>::getIdentifier()->getObjects()->end().element_); }
 
-            /** @brief Returns the first element in the list. @return The first element */
-            inline static Iterator<T> begin()
-                { return Iterator<T>(ClassIdentifier<T>::getIdentifier()->getObjects()->first_); }
+            /** @brief Returns an Iterator to the last element in the list. @return The Iterator */
+            inline static ObjectListElement<T>* rbegin()
+                { return ((ObjectListElement<T>*)ClassIdentifier<T>::getIdentifier()->getObjects()->rbegin().element_); }
 
-            /** @brief Returns the last element in the list. @return The last element */
-            inline static Iterator<T> end()
-                { return Iterator<T>(ClassIdentifier<T>::getIdentifier()->getObjects()->last_); }
-
-            inline void registerIterator(Iterator<T>* iterator)
-                { this->iterators_.insert(this->iterators_.end(), (void*)iterator); }
-            inline void unregisterIterator(Iterator<T>* iterator)
-                { this->iterators_.erase((void*)iterator); }
-            void notifyIterators(ObjectListElement<T>* element);
-
-            ObjectListElement<T>* first_;       //!< The first element in the list
-            ObjectListElement<T>* last_;        //!< The last element in the list
-
-        private:
-            std::set<void*> iterators_;  //!< A list of iterators pointing on an element in this list
+            /** @brief Returns an Iterator to the element before the first element in the list. @return The Iterator */
+            inline static ObjectListElement<T>* rend()
+                { return ((ObjectListElement<T>*)ClassIdentifier<T>::getIdentifier()->getObjects()->rend().element_); }
     };
-
-    /**
-        @brief Constructor: Sets default values.
-    */
-    template <class T>
-    ObjectList<T>::ObjectList()
-    {
-        this->first_ = 0;
-        this->last_ = 0;
-    }
-
-    /**
-        @brief Destructor: Deletes all list-elements, but NOT THE OBJECTS.
-    */
-    template <class T>
-    ObjectList<T>::~ObjectList()
-    {
-        ObjectListElement<T>* temp;
-        while (this->first_)
-        {
-            temp = this->first_->next_;
-            delete this->first_;
-            this->first_ = temp;
-        }
-    }
-
-    /**
-        @brief Increases all Iterators that currently point on the given element (because it gets removed).
-        @param element The element that gets removed
-    */
-    template <class T>
-    void ObjectList<T>::notifyIterators(ObjectListElement<T>* element)
-    {
-        for (std::set<void*>::iterator it = this->iterators_.begin(); it != this->iterators_.end(); ++it)
-            if ((*(*((Iterator<T>*)(*it)))) == element->object_)
-                ++(*((Iterator<T>*)(*it)));
-    }
-
-    /**
-        @brief Adds a new object to the end of the list.
-        @param object The object to add
-        @return The pointer to the new ObjectListElement, needed by the MetaObjectList of the added object
-    */
-    template <class T>
-    ObjectListElement<T>* ObjectList<T>::add(T* object)
-    {
-        if (!this->last_)
-        {
-            // If the list is empty
-            this->last_ = new ObjectListElement<T>(object);
-            this->first_ = this->last_; // There's only one object in the list now
-        }
-        else
-        {
-            // If the list isn't empty
-            ObjectListElement<T>* temp = this->last_;
-            this->last_ = new ObjectListElement<T>(object);
-            this->last_->prev_ = temp;
-            temp->next_ = this->last_;
-        }
-
-        return this->last_;
-    }
 }
 
Index: code/trunk/src/core/ObjectListBase.cc
===================================================================
--- code/trunk/src/core/ObjectListBase.cc	(revision 1747)
+++ code/trunk/src/core/ObjectListBase.cc	(revision 1747)
@@ -0,0 +1,107 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file ObjectListBase.cc
+    @brief Implementation of the ObjectListBase class.
+
+    The ObjectListBase is a double-linked list, used by Identifiers to store all objects of a given class.
+    Newly created objects are added through the RegisterObject-macro in its constructor.
+*/
+
+#include <set>
+
+#include "CorePrereqs.h"
+
+#include "ObjectListBase.h"
+#include "Identifier.h"
+#include "Iterator.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Sets default values.
+    */
+    ObjectListBase::ObjectListBase(Identifier* identifier)
+    {
+        this->identifier_ = identifier;
+        this->first_ = 0;
+        this->last_ = 0;
+    }
+
+    /**
+        @brief Destructor: Deletes all list-elements, but NOT THE OBJECTS.
+    */
+    ObjectListBase::~ObjectListBase()
+    {
+        ObjectListBaseElement* temp;
+        while (this->first_)
+        {
+            temp = this->first_->next_;
+            delete this->first_;
+            this->first_ = temp;
+        }
+    }
+
+    /**
+        @brief Increases all Iterators that currently point on the given element (because it gets removed).
+        @param element The element that gets removed
+    */
+    void ObjectListBase::notifyIterators(OrxonoxClass* object) const
+    {
+        for (std::list<void*>::const_iterator it = this->iterators_.begin(); it != this->iterators_.end(); ++it)
+            ((Iterator<OrxonoxClass>*)(*it))->incrementIfEqual(object);
+        for (std::list<void*>::const_iterator it = this->objectListIterators_.begin(); it != this->objectListIterators_.end(); ++it)
+            ((ObjectListIterator<OrxonoxClass>*)(*it))->incrementIfEqual(object);
+    }
+
+    /**
+        @brief Adds a new object to the end of the list.
+        @param object The object to add
+        @return The pointer to the new ObjectListBaseElement, needed by the MetaObjectList of the added object
+    */
+    ObjectListBaseElement* ObjectListBase::add(ObjectListBaseElement* element)
+    {
+        if (!this->last_)
+        {
+            // If the list is empty
+            this->last_ = element;
+            this->first_ = this->last_; // There's only one object in the list now
+        }
+        else
+        {
+            // If the list isn't empty
+            ObjectListBaseElement* temp = this->last_;
+            this->last_ = element;
+            this->last_->prev_ = temp;
+            temp->next_ = this->last_;
+        }
+
+        return this->last_;
+    }
+}
Index: code/trunk/src/core/ObjectListBase.h
===================================================================
--- code/trunk/src/core/ObjectListBase.h	(revision 1747)
+++ code/trunk/src/core/ObjectListBase.h	(revision 1747)
@@ -0,0 +1,129 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file ObjectListBase.h
+    @brief Definition of the ObjectListBase class.
+
+    The ObjectListBase is a double-linked list, used by Identifiers to store all objects of a given class.
+    Newly created objects are added through the RegisterObject-macro in its constructor.
+*/
+
+#ifndef _ObjectListBase_H__
+#define _ObjectListBase_H__
+
+#include <list>
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+    // ###############################
+    // ###  ObjectListBaseElement  ###
+    // ###############################
+    //! The list-element of the ObjectListBase
+    class _CoreExport ObjectListBaseElement
+    {
+        public:
+            /**
+                @brief Constructor: Creates the list-element with an object.
+                @param object The object to store
+            */
+            ObjectListBaseElement(OrxonoxClass* objectBase) : next_(0), prev_(0), objectBase_(objectBase) {}
+
+            ObjectListBaseElement* next_;       //!< The next element in the list
+            ObjectListBaseElement* prev_;       //!< The previous element in the list
+            OrxonoxClass* objectBase_;
+    };
+
+
+    // ###############################
+    // ###    ObjectListElement    ###
+    // ###############################
+    //! The list-element that actually contains the object
+    template <class T>
+    class ObjectListElement : public ObjectListBaseElement
+    {
+        public:
+            ObjectListElement(T* object) : ObjectListBaseElement(object), object_(object) {}
+            T* object_;              //!< The object
+    };
+
+
+    // ###############################
+    // ###     ObjectListBase      ###
+    // ###############################
+    //! The ObjectListBase contains all objects of a given class.
+    /**
+        The ObjectListBase is used by Identifiers to store all objects of their given class.
+        Use ObjectList<T> to get the list of all T's and Iterator<T> to iterate through them.
+    */
+    class _CoreExport ObjectListBase
+    {
+        friend class MetaObjectListElement;
+
+        public:
+            ObjectListBase(Identifier* identifier);
+            ~ObjectListBase();
+
+            ObjectListBaseElement* add(ObjectListBaseElement* element);
+
+            struct Export
+            {
+                Export(ObjectListBase* list, ObjectListBaseElement* element) : list_(list), element_(element) {}
+                ObjectListBase* list_;
+                ObjectListBaseElement* element_;
+            };
+
+            /** @brief Returns a pointer to the first element in the list. @return The element */
+            inline Export begin() { return ObjectListBase::Export(this, this->first_); }
+            /** @brief Returns a pointer to the element after the last element in the list. @return The element */
+            inline Export end() { return ObjectListBase::Export(this, 0); }
+            /** @brief Returns a pointer to the last element in the list. @return The element */
+            inline Export rbegin() { return ObjectListBase::Export(this, this->last_); }
+            /** @brief Returns a pointer to the element in front of the first element in the list. @return The element */
+            inline Export rend() { return ObjectListBase::Export(this, 0); }
+
+            inline std::list<void*>::iterator registerIterator(void* iterator) { return this->iterators_.insert(this->iterators_.begin(), iterator); }
+            inline void unregisterIterator(const std::list<void*>::iterator& iterator) { this->iterators_.erase(iterator); }
+            inline std::list<void*>::iterator registerObjectListIterator(void* iterator) { return this->objectListIterators_.insert(this->objectListIterators_.begin(), iterator); }
+            inline void unregisterObjectListIterator(const std::list<void*>::iterator& iterator) { this->objectListIterators_.erase(iterator); }
+            void notifyIterators(OrxonoxClass* object) const;
+
+            inline Identifier* getIdentifier() const { return this->identifier_; }
+
+        private:
+            Identifier* identifier_;               //!< The Iterator owning this list
+            ObjectListBaseElement* first_;         //!< The first element in the list
+            ObjectListBaseElement* last_;          //!< The last element in the list
+            std::list<void*> iterators_;           //!< A list of Iterators pointing on an element in this list
+            std::list<void*> objectListIterators_; //!< A list of ObjectListIterators pointing on an element in this list
+    };
+}
+
+#endif /* _ObjectListBase_H__ */
